require 'swiftcore/evented_mongrel'
require 'merb-core/rack/handler/mongrel'
module Merb
  module Rack

    class EventedMongrel < Mongrel
      # Starts Mongrel as evented.
      #
      # ==== Parameters
      # opts<Hash>:: Options for Mongrel (see below).
      #
      # ==== Options (opts)
      # :host<String>:: The hostname that Mongrel should serve.
      # :port<Fixnum>:: The port Mongrel should bind to.
      # :app<String>>:: The application name.
      def self.start(opts={})
        Merb.logger.info("Using EventedMongrel adapter: #{opts.inspect}")
        Merb.logger.flush
        server = ::Mongrel::HttpServer.new(opts[:host], opts[:port].to_i)
        server.register('/', ::Merb::Rack::Handler::Mongrel.new(opts[:app]))
        server.run.join
      end
    end
  end
end